<?php

class nextpayvalidationModuleFrontController extends ModuleFrontController
{
	public function postToNextPay($path, $parameters)
	{
		$url ='https://nextpay.org/nx/gateway/'.$path;
		
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json'));
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS,json_encode($parameters));
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		$response  = curl_exec($ch);
		curl_close($ch);
		return json_decode($response);
	}

	function statusCodes($code)
{
    switch ($code) 
    {
        case 'OK':
            return "پرداخت شده، در انتظار تایید";

        case 'Unsuccessful':
            return "ناموفق";
        default:
            return "وضعیت مشخص شده معتبر نیست";
    }
}

	private function resultCodes($error)
	{
		$response = '';
		switch ($error) {
			case '0':
				$response = 'با موفقیت تایید شد.';
				break;

			case '-20':
				$response = 'API_KEY یافت نشد.';
				break;

			case '-39':
				$response = 'API_KEY غیرفعال';
				break;

			case '-40':
				$response = 'API_KEY نامعتبر';
				break;

			
			case '-30':
				$response = 'amount بایستی بزرگتر از 1,000 ریال باشد.';
				break;

			case '-32':
				$response = 'callback_uri نامعتبر می‌باشد. (شروع با http و یا https';
				break;
			case '-4':
				$response = 'سفارش پرداخت نشده یا ناموفق بوده است.';
				break;

			case '-34':
				$response = 'trans_id نامعتبر می‌باشد.';
				break;
			default:
				$response = "وضعیت مشخص شده معتبر نیست";
				break;
		}

		return $response;
	}


    public function postProcess()
    {
        $cart = $this->context->cart;

        if ($cart->id_customer == 0 || $cart->id_address_delivery == 0 || $cart->id_address_invoice == 0 || !$this->module->active) {
            Tools::redirect('index.php?controller=order&step=1');
        }
        $authorized = false;
        foreach (Module::getPaymentModules() as $module) {
            if ($module['name'] == 'nextpay') {
                $authorized = true;
                break;
            }
        }

        if (!$authorized) {
            die($this->trans('This payment method is not available.', array(), 'Modules.nextpay.Shop'));
        }

        $customer = new Customer($cart->id_customer);

        if (!Validate::isLoadedObject($customer)) {
            Tools::redirect('index.php?controller=order&step=1');
        }

        $currency = $this->context->currency;
        $total = (float)$cart->getOrderTotal(true, Cart::BOTH);

		$statusCode = $_GET['np_status'];
		$trackId = isset($_GET['trans_id']) ? $_GET['trans_id'] : -1;
		//$np_amount = isset($_GET['amount']) ? $_GET['amount'] : 0;
		$orderId = Tools::getValue('paid');
        $order = new Order($orderId);
		if ($statusCode == 'OK')
		{
			
			
			

				if($currency->iso_code == 'IRR') {
					$newTotal = round(floatval($total));
				} else {
					$newTotal = round(floatval($total)) * 10;
				}
					
					
				// echo "amount: "; var_dump($result->amount);
				// echo "newTotal: "; var_dump($newTotal);
				// die();
				
				$np_amount = intval($newTotal/10);
				
				$data = array(
					'api_key' => Configuration::get('NEXTPAY_MERCHANT'),
					'trans_id'  => $trackId,
					'amount' => $np_amount,
				);

				$result = $this->postToNextPay('verify', $data);
			if ($result->code == '0') {
				
					$this->module->validateOrder((int)$cart->id, _PS_OS_PAYMENT_, $total, $this->module->displayName, "سفارش تایید شده / کد رهگیری :".$result->Shaparak_Ref_Id,array(), (int)$currency->id, false, $customer->secure_key);
					
					Tools::redirect('index.php?controller=order-confirmation&id_cart='.(int)$cart->id.'&id_module='.(int)$this->module->id.'&id_order='.$this->module->currentOrder.'&key='.$customer->secure_key);

					$message ='پرداخت انجام شد.';
					
				
				
				
			} else {
					$message ='خطایی رخ داد کد خطا : '.$result->code;
				}
		   
		}
		else
		{
			$message = $this->statusCodes($statusCode);
		}
		
		
		 if ((bool)Context::getContext()->customer->is_guest) {
				$url=Context::getContext()->link->getPageLink('guest-tracking', true);
			} else {
				$url=Context::getContext()->link->getPageLink('history', true);
			}
			
		 $this->context->smarty->assign([
				'message' => $message,
				'redirectUrl' => $url,
				'orderReference' => $order->reference,

			]);
			
			return $this->setTemplate('module:nextpay/back.tpl');
    }
	
}
